<?php

/**
 * Class get information to service.
 *
 * @author juanfrasr
 */
class kpaxSrv {

    protected $url = "http://localhost:8081";
    private $key;
    private $username;
    //private $apiKey = "e4afd792d8730dded98e67ac6e9752bd35e764bc"; // Public API key generated by elgg
    private $apiKey = "95d01c544da3d839f414c1f16376694693ff8376";// Public API key generated by elgg
    private $oauthKpax = null;

  /**
   * CONSTRUCTOR
   */
  public function __construct($username) { //TODO: ha de ser kPAXadmin o admin per defecte???
    $this->oauthKpax = new kpaxOauth();

    $this->userName = str_replace("uoc.edu_", "", $userName); //Case UOC login
    $body = 'username=' . trim($this->userName . "&apikey=" . $this->apiKey);

    //TODO: user/sign/elgg
    //TODO: save session
    // $_SESSION["campusSession"] = $this->service("user/sign/elgg", "POST", $body);

    $_SESSION["campusSession"] = 'campus_session';
  }

    //TODO
    public function getKey() {
        return $this->key;
    }

    //TODO
    public function oauth($key,$secret){
        $this->oauthKpax->setKeySecret($key, $secret);
    }

  /**
   * HTTP call. Makes an http call
   *
   * @return { status: {Integer}, body: {JSON}, raw: {String}}
   */
  private function service($action, $type = 'GET', $body = '', $header = 'application/json') {
      //TODO: fix signature
      $signature = $this->oauthKpax->getSignature($type, $this->url . $action);

      $url = $this->url . $action;

      error_log("** REQUEST: " . $type . " " . $url);

      if ($body != '') {
        $content = json_encode($body);
      }

      $options = array('http' =>
        array (
          'method' => $type,
          'header' => 'Content-Type: ' . $header,
          'content' => $content
        )
      );

      //PROBLEMS
      $body = file_get_contents($url, false, stream_context_create($options));
      $status = $this->getHttpStatus($http_response_header);

      error_log('** RESPONSE: ' . $status . ' ' . $body);
      error_log("** ------------------------------");

      return array(
        'status' => $status,
        'body' => json_decode($body),
        'raw' => $body
      );
  }

  /**
   * Return response code
   * From Mangall http://php.net/manual/en/reserved.variables.httpresponseheader.php
   *
   * @return {Integer}
   */
  private function getHttpStatus ($headers) {
    $status = 0;
    //PROBLEMS
    foreach ($headers as $k=>$v) {
      $t = explode( ':', $v, 2 );
      if(!isset( $t[1])) {
        // parse status
        if(preg_match( "#HTTP/[0-9\.]+\s+([0-9]+)#", $v, $out)) {
          $status = intval($out[1]);
        }
      }
    }

    return $status;
  }

  /**
   * getListGames
   * API2
   */
  public function getGame($gameId, $campusSession) {
    return $this->service('/game/' . $gameId);
  }

    //TODO (other plugin?)
    public function addLikeGame($campusSession, $containerId, $productId) {
      $body = 'secretSession=' . $campusSession . '&containerId=' . $containerId;
      //return $this->service("/game/like/" . $productId . "/add", "POST", $body);
      return $this->service("/game/" . $productId . "/like/", "POST", $body);
    }

    //TODO (other plugin?)
    public function delLikeGame($campusSession, $containerId, $productId) {
        $body = 'secretSession=' . $campusSession . '&containerId=' . $containerId;
        //$this->service("/game/like/" . $productId . "/del", "POST", $body);
        $this->service("/game/" . $productId . "/unlike/", "POST", $body);
    }

    //TODO (other plugin?)
    public function getLikesGame($campusSession, &$entity) {
      //return $this->service("/game/like/" . $campusSession . "/list/" . $entity->getGuid());
      return $this->service("/game/" . $campusSession . "/list/" . $entity->getGuid());
    }

    //TODO (other plugin?)
    public function getLikeGame($campusSession, $idEntity) {
      //return $this->service("/game/like/" . $campusSession . "/get/" . $idEntity);
      return $this->service("/game/" . $campusSession . "/get/" . $idEntity);
    }

  /**
   * getListGames
   * API2
   */
  public function delGame($campusSession, $idGame) {
    $body = 'secretSession=' . $campusSession;
    return $this->service('/game/' . $idGame, 'DELETE');
  }

    //TODO (other plugin?)
    public function getScore($gameUid) {
        if ($gameUid == '') $gameUid = '0';
        return $objScore = $this->service("/game/score/" . $gameUid . "/list/");
    }

  /**
   * getListGames
   * API2
   */
  public function getListGames($campusSession, $idOrderer, $idFilterer, $fields, $values) {
    $body = 'secretSession=' . $campusSession;
    $count = count($fields);
    for ($i = 0; $i < $count; $i++) {
      $body = $body . "&fields=" . $fields[$i] . "&values=" . $values[$i];
    }

    return $this->service('/game/list?order=' . $idOrderer . '&filter=' . $idFilterer);
  }

  /**
   * getUserListGames
   * API2
   */
  public function getUserListGames($owner, $campusSession) {
    return $this->service('/game/list?q={owner:' . $owner. '}' );

  }

  /**
   * addGame
   * API2
   *
   * $kPAXgame->subtype = "kpax";
   * $kPAXgame->container_guid = (int) get_input('container_guid', $owner); // bobo - del? $_SESSION['user']->getGUID());
   * $kPAXgame->title = $title;
   * $kPAXgame->description = $description;
   * $kPAXgame->idCategory = $category; //NOU
   * $kPAXgame->access_id = ACCESS_LOGGED_IN; // by default, the game is public
   * $kPAXgame->owner_guid = $owner; // by default, the developer is the logged in user
   * $kPAXgame->tags = $tags;        // save tags as metadata
   */
  public function addGame($campusSession, $obj) {
    $body = array (
      'secretSession' => $campusSession,
      'owner' => $obj->owner_guid,
      'name' => $obj->title,
      'description' => $obj->description,
      'category' => $obj->idCategory,
      'tags' => $obj->tags
    );

    return $this->service('/game/' . strval($obj->getGUID()), 'POST', $body);
  }

    //TODO (other plugin?)
    public function getCategories($campusSession) {
        $listCategories = $this->service("/game/category/list?" . $campusSession);
        return $listCategories;
    }

  /**
   * addGame
   * API2
   */
  public function getCategory($campusSession, $idCategory) {
    if ($idCategory == '') $idCategory = '0';
    $objCategory = $this->service('/game/category/' . $idCategory );
    return $objCategory;
  }

    //TODO (other plugin?)
    public function getCommentsGame($campusSession, $idGame) {
      return $this->service("/game/comment/" . $campusSession . "/list/" . $idGame);
    }

    //TODO (other plugin?)
    public function addCommentGame($campusSession, $idGame, $idComment) {
        $body = 'secretSession=' . $campusSession . "&idGame=" . $idGame;
        return $this->service("/game/comment/" . $idComment . "/add/", "POST", $body);
    }

    //TODO (other plugin?)
    public function delCommentGame($campusSession, $idComment) {
        $body = 'secretSession=' . $campusSession . '&containerId=' . $containerId;
        return $this->service("/game/comment/" . $idComment . "/del/", "POST", $body);
    }

    //TODO (other plugin?)
    public function getTagsGame($campusSession, $idGame) {
        return $this->service("/game/tag/" . $campusSession . "/list/" . $idGame);
        return $listTags;
    }

    //DEL because is in the game itself
    // public function addDelTagsGame($campusSession, $idGame, $tagsCommaSeparated) {
    //     $body = 'secretSession=' . $campusSession . '&tags=' . $tagsCommaSeparated;
    //     return $this->service("game/tag/" . $idGame . "/addDel", "POST", $body);
    // }
    
    //Add by @javierrami for kpaxlist
    
    
}

?>
